<template>
  <div class="ele-body">
    <a-card :bordered="false">
      <!-- 表格 -->
      <ele-pro-table
        ref="tableRef"
        row-key="userId"
        :columns="columns"
        :datasource="datasource"
        v-model:selection="selection"
        :scroll="{ x: 1300 }"
        :where="defaultWhere"
        :customRow="customRow"
        cache-key="proSystemUserTable"
      >
        <template #toolbar>
          <a-space>
            <a-button type="primary" class="ele-btn-icon" @click="openEdit()">
              <template #icon>
                <plus-outlined />
              </template>
              <span>新建</span>
            </a-button>
            <a-button
              type="primary"
              class="ele-btn-icon"
              @click="openEdit(selection[0])"
              :disabled="selection.length === 0"
            >
              <template #icon>
                <EditOutlined />
              </template>
              <span>修改</span>
            </a-button>
            <a-button
              type="primary"
              danger
              @click="resetPsw(selection[0])"
              :disabled="selection.length === 0"
              >重置密码</a-button
            >
            <a-button
              danger
              type="primary"
              class="ele-btn-icon"
              @click="removeBatch"
            >
              <template #icon>
                <delete-outlined />
              </template>
              <span>批量删除</span>
            </a-button>
            <a-button type="dashed" class="ele-btn-icon" @click="openImport">
              <template #icon>
                <upload-outlined />
              </template>
              <span>导入</span>
            </a-button>
            <a-input-search
              allow-clear
              v-model:value="searchText"
              placeholder="请输入关键词"
              @search="reload"
              @pressEnter="reload"
            />
          </a-space>
        </template>
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'nickname'">
            <div class="user-box">
              <a-avatar
                :size="30"
                :src="`${record.avatar}`"
                style="margin-right: 4px"
              >
                <template #icon>
                  <UserOutlined />
                </template>
              </a-avatar>
              <div class="user-info" @click="openEdit(record)">
                <span>{{ record.realName }}</span>
                <span class="ele-text-placeholder">{{ record.nickname }}</span>
              </div>
            </div>
          </template>
          <template v-else-if="column.key === 'roles'">
            <a-tag v-for="item in record.roles" :key="item.roleId" color="blue">
              {{ item.roleName }}
            </a-tag>
          </template>
          <template v-if="column.key === 'balance'">
            <span class="ele-text-success">
              ￥{{ formatNumber(record.balance) }}
            </span>
          </template>
          <!--          <template v-if="column.key === 'introduction'">-->
          <!--            <a-tooltip :title="`${record.introduction}`">-->
          <!--              {{ record.introduction }}-->
          <!--            </a-tooltip>-->
          <!--          </template>-->
          <template v-if="column.key === 'expendMoney'">
            <span class="ele-text-warning">
              ￥{{ formatNumber(record.expendMoney) }}
            </span>
          </template>
          <template v-if="column.key === 'userLevel'">
            <span>
              {{ USER_LEVEL_LIST[record.userLevel] }}
            </span>
          </template>
          <template v-else-if="column.key === 'status'">
            <a-switch
              :checked="record.status === 0"
              @change="(checked: boolean) => editStatus(checked, record)"
            />
          </template>
          <template v-else-if="column.key === 'action'">
            <a-space>
              <a-button @click="openEdit(record)">修改</a-button>
              <a-divider type="vertical" />
              <a-button @click="resetPsw(record)">重置密码</a-button>
              <!--              <a-divider type="vertical" />-->
              <!--              <a-popconfirm-->
              <!--                placement="topRight"-->
              <!--                title="确定要删除此用户吗？"-->
              <!--                @confirm="remove(record)"-->
              <!--              >-->
              <!--                <a class="ele-text-danger">删除</a>-->
              <!--              </a-popconfirm>-->
            </a-space>
          </template>
        </template>
      </ele-pro-table>
    </a-card>
    <!-- 编辑弹窗 -->
    <user-edit
      v-model:visible="showEdit"
      :data="current"
      :organization-list="data"
      @done="reload"
    />
    <!-- 导入弹窗 -->
    <user-import v-model:visible="showImport" @done="reload" />
    <!-- 用户详情 -->
    <user-info v-model:visible="showInfo" :data="current" @done="reload" />
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref, reactive } from 'vue';
  import { message, Modal } from 'ant-design-vue/es';
  import {
    PlusOutlined,
    DeleteOutlined,
    UploadOutlined,
    EditOutlined,
    UserOutlined,
    ExclamationCircleOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro/es';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { messageLoading, formatNumber } from 'ele-admin-pro/es';
  import { timeAgo } from 'ele-admin-pro';
  import UserEdit from './components/user-edit.vue';
  import UserImport from './components/user-import.vue';
  import UserInfo from './components/user-info.vue';
  import {
    pageUsers,
    removeUser,
    removeUsers,
    updateUserStatus,
    updateUserPassword
  } from '@/api/system/user';
  import type { User, UserParam } from '@/api/system/user/model';
  import { toTreeData, uuid } from 'ele-admin-pro';
  import { listRoles } from '@/api/system/role';
  import { getDictionaryOptions } from '@/utils/common';
  import { listOrganizations } from '@/api/system/organization';
  import { Organization } from '@/api/system/organization/model';
  import { USER_LEVEL_LIST } from "@/api/system/user/model";

  // 加载状态
  const loading = ref(true);
  // 树形数据
  const data = ref<Organization[]>([]);
  // 树展开的key
  const expandedRowKeys = ref<number[]>([]);
  // 树选中的key
  const selectedRowKeys = ref<number[]>([]);
  // 表格选中数据
  const selection = ref<User[]>([]);
  // 当前编辑数据
  const current = ref<User | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示用户详情
  const showInfo = ref(false);
  // 是否显示用户导入弹窗
  const showImport = ref(false);
  const userType = ref<number>();
  const searchText = ref('');

  // 加载角色
  const roles = ref<any[]>([]);
  const filters = () => {
    listRoles().then((result) => {
      result.map((d) => {
        roles.value.push({
          text: d.roleName,
          value: d.roleId
        });
      });
    });
  };
  filters();
  // 加载机构
  listOrganizations()
    .then((list) => {
      loading.value = false;
      const eks: number[] = [];
      list.forEach((d) => {
        d.key = d.organizationId;
        d.value = d.organizationId;
        d.title = d.organizationName;
        if (typeof d.key === 'number') {
          eks.push(d.key);
        }
      });
      expandedRowKeys.value = eks;
      data.value = toTreeData({
        data: list,
        idField: 'organizationId',
        parentIdField: 'parentId'
      });
      if (list.length) {
        if (typeof list[0].key === 'number') {
          selectedRowKeys.value = [list[0].key];
        }
        // current.value = list[0];
      } else {
        selectedRowKeys.value = [];
        // current.value = null;
      }
    })
    .catch((e) => {
      loading.value = false;
      message.error(e.message);
    });

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);
  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: 'ID',
      dataIndex: 'userId',
      sorter: true,
      width: 80,
      showSorterTooltip: false
    },
    {
      title: '登录账号',
      dataIndex: 'username',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '用户名称',
      key: 'nickname',
      dataIndex: 'nickname',
      width: 280,
      sorter: true,
      showSorterTooltip: false
    },
    // {
    //   title: '客户分组',
    //   dataIndex: 'type',
    //   key: 'type',
    //   align: 'center',
    //   width: 120,
    //   customRender: ({ text }) => typeName(text)
    // },
    {
      title: '手机号',
      dataIndex: 'phone',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '性别',
      dataIndex: 'sexName',
      width: 80,
      align: 'center',
      sorter: true,
      showSorterTooltip: false
    },
    {
      title: '邮箱',
      dataIndex: 'email',
      width: 180,
      sorter: true,
      hideInTable: true,
      showSorterTooltip: false
    },
    {
      title: '角色',
      dataIndex: 'roles',
      key: 'roles',
      align: 'center',
      width: 120,
      filterMultiple: false,
      filters: roles.value
    },
    {
      title: '小程序权限',
      dataIndex: 'userLevel',
      key: 'userLevel',
      align: 'center',
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      sorter: true,
      showSorterTooltip: false,
      ellipsis: true,
      customRender: ({ text }) => timeAgo(text)
    },
    {
      title: '状态',
      key: 'status',
      dataIndex: 'status',
      sorter: true,
      showSorterTooltip: false,
      width: 90,
      align: 'center'
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      fixed: 'left',
      align: 'center'
    },
  ]);

  // 默认搜索条件
  const defaultWhere = reactive({
    username: '',
    nickname: ''
  });

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    where = {};
    where.roleId = filters.roles;
    where.keywords = searchText.value;
    return pageUsers({ page, limit, ...where, ...orders });
  };

  /* 搜索 */
  const reload = (where?: UserParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: User) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开用户详情弹窗 */
  const openInfo = (row?: User) => {
    current.value = row ?? null;
    showInfo.value = true;
  };

  /* 打开编辑弹窗 */
  const openImport = () => {
    showImport.value = true;
  };

  const handleTabs = (e) => {
    userType.value = Number(e.target.value);
    reload();
  };

  /* 删除单个 */
  const remove = (row: User) => {
    const hide = messageLoading('请求中..', 0);
    removeUser(row.userId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的用户吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = messageLoading('请求中..', 0);
        removeUsers(selection.value.map((d) => d.userId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 重置用户密码 */
  const resetPsw = (row: User) => {
    Modal.confirm({
      title: '提示',
      content: '确定要重置此用户的密码吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        const password = uuid(8);
        updateUserPassword(row.userId, password)
          .then((msg) => {
            hide();
            message.success(msg + '，新密码：' + password);
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 修改用户状态 */
  const editStatus = (checked: boolean, row: User) => {
    const status = checked ? 0 : 1;
    updateUserStatus(row.userId, status)
      .then((msg) => {
        row.status = status;
        message.success(msg);
      })
      .catch((e) => {
        message.error(e.message);
      });
  };

  /* 自定义行属性 */
  const customRow = (record: User) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
</script>

<script lang="ts">
  export default {
    name: 'SystemUser'
  };
</script>

<style lang="less" scoped>
  .user-box {
    display: flex;
    align-items: center;
    .user-info {
      display: flex;
      flex-direction: column;
      align-items: start;
    }
  }
</style>
